#include "opencv2/core/core.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/ocl/ocl.hpp"
#include "iostream"
#include <sys/time.h>
#include "time-calculation.hpp"


 
using namespace cv;

 
int main( )
{
    //Timer time;
    //time.start();
    ocl::DevicesInfo devInfo;
    int res = ocl::getOpenCLDevices(devInfo);
    if(res == 0)
    {
        std::cerr << "There is no OPENCL Here !" << std::endl;
        return -1;
    }
    else
    {
        for(unsigned int i = 0 ; i < devInfo.size() ; ++i)
        {
	  std::cout << "Device : " << devInfo[i]->deviceName << " is present" << std::endl;
        }
    }

    ocl::setDevice(devInfo[0]);        // select device to use
    std::cout << CV_VERSION_EPOCH << "." << CV_VERSION_MAJOR << "." << CV_VERSION_MINOR << std::endl;

    Mat src1;
    src1 = imread("lena.jpg", CV_LOAD_IMAGE_COLOR);
    namedWindow( "Original image", CV_WINDOW_AUTOSIZE );
    imshow( "Original image", src1 );
 
    //Mat edge, draw;
    Mat edge;
    ocl::oclMat conv, src_gray;
    
    ocl::oclMat oclmat_src(src1);
      
    //ocl::cvtColor(src1, gray, COLOR_RGB2GRAY);
    ocl::cvtColor( oclmat_src, src_gray, COLOR_RGB2GRAY );
    
    //ocl::oclMat dst(gray);
    ocl::Canny(src_gray, conv, 50, 150, 3);
    edge = conv;
    //ocl::finish();
    //edge.convertTo(draw, CV_8U);
    //time.stop;
    //std::cout<< "Time taken by Canny:" << time.getElapsedTimeInMilliSec() << "msecs" << std::endl;
    namedWindow("image", CV_WINDOW_AUTOSIZE);
    //imshow("image", draw);
    imshow("image", edge);
 
    waitKey(0);                                       
    return 0;
} 
